% Swaping phase on audio signals

% Load waveforms


[x1,fs,bts] = wavread('F1.WAV');
[x2,fs,bts] = wavread('M3.wav');

N1 = size(x1,1);
N2 = size(x2,1);
N = min([N1,N2]);

s1 = x1(1:N,1);
s2 = x2(1:N,1);

figure(1)
plot(1:N,s1,'g',1:N,s2,'b')
title('Original signals')


%Windows definition
M1 = 256;
M = 2*M1;
b = M1;
F = M;
awin = [ones(M1,1);zeros(M1,1)];
swin = [ones(M1,1);zeros(M1,1)];

% TF analysis
k = 0;
for t=1:b:N-M
    k = k+1;
    S1(1:F,k) = fft(s1(t:t+M-1).*awin,F);
    S2(1:F,k) = fft(s2(t:t+M-1).*awin,F);
end
Nk = k;

% Swap phases
NS1 = abs(S1).* (S2./(1e-8+abs(S2)));
NS2 = abs(S2).* (S1./(1e-8+abs(S1)));

%NS1=S1;
%NS2=S2;

% TF synthesis
ns1 = zeros(N,1);
ns2 = zeros(N,1);

t = 1;
for k=1:Nk
    ss1 = ifft(NS1(1:F,k),F).*swin;
    ns1(t:t+M-1,1) = ns1(t:t+M-1,1) + ss1(1:M,1);
    ss2 = ifft(NS2(1:F,k),F).*swin;
    ns2(t:t+M-1,1) = ns2(t:t+M-1,1) + ss2(1:M,1);
    t = t+b;
end

Tt = size(ns1,1);

figure(2)
plot(1:Tt,ns1,'g',1:Tt,ns2,'b')
title('New signals')

wavwrite(ns1,fs,bts,'newsig1.wav');
wavwrite(ns2,fs,bts,'newsig2.wav');
