clear;
clc;

%% Load the images
I1 = double( imread('Lena.bmp'));
I2 = double( imread('Pepper.bmp'));

%% FFT
I1_hat = fft2(I1);
I2_hat = fft2(I2);

%% With redundancy
I1_hat_red = fft2(I1,size(I1,1)*2,size(I1,2)*2);
I2_hat_red = fft2(I2,size(I2,1)*2,size(I2,2)*2);

%% Exchange the phases
J1_hat = abs(I2_hat).*I1_hat./abs(I1_hat);
J2_hat = abs(I1_hat).*I2_hat./abs(I2_hat);

J1_hat_red = abs(I2_hat_red).*I1_hat_red./abs(I1_hat_red);
J2_hat_red = abs(I1_hat_red).*I2_hat_red./abs(I2_hat_red);

%% IFFT
J1 = ifft2(J1_hat);
J2 = ifft2(J2_hat);

J1_inv = ifft2(J1_hat_red);
J2_inv = ifft2(J2_hat_red);

J1_red = J1_inv(1:size(I1,1),1:size(I1,2));
J2_red = J2_inv(1:size(I2,1),1:size(I2,2));

% Convert into uint8
maxintfig = max([max(max(I1)),max(max(I2)),max(max(J1)),max(max(J2)),max(max(J1_red)),max(max(J2_red))]);
I1uint8 = uint8(I1*255/maxintfig);
I2uint8 = uint8(I2*255/maxintfig);

J1uint8 = uint8(J1*255/maxintfig);
J2uint8 = uint8(J2*255/maxintfig);

J1_reduint8 = uint8(J1_red*255/maxintfig);
J2_reduint8 = uint8(J2_red*255/maxintfig);

%% Show the pics
figure(1);
subplot(1,2,1);
imshow(I1uint8);
subplot(1,2,2);
imshow(J1uint8);

figure(2);
subplot(1,2,1);
imshow(I2uint8);
subplot(1,2,2);
imshow(J2uint8);

figure(3);
subplot(1,2,1);
imshow(I1uint8);
subplot(1,2,2);
imshow(J1_reduint8);

figure(4);
subplot(1,2,1);
imshow(I2uint8);
subplot(1,2,2);
imshow(J2_reduint8);
