%% Setting
n = 4; % dimension of signal
m = 2*n-1; % # of measurements
x = rand(n,1); % the signal to recover

%% FFT with redund
% `circshift'' is used - the indices are the same as in the lecture notes
x_m = [0;x;zeros(n-2,1)];
X = circshift(fft(x_m),-1);
X2 = abs(X).^2;

%% IFFT
R = circshift(ifft(circshift(X2,1)),n-1);
r0 = R(n);
Z = roots(R);

%% Partitions of the root set of R(z)
% We do a partition of roots according to R(z) = X(z)Xbar(1/z)
% The roots in one subset are stored in a matrix D

D = zeros(2,n-1);
sol = 0; % x-dim index of D, # of soln
pos = 0; % y-dim index of D

while size(Z,1) ~= 0
    z = Z(1);
    Z(1) = 0;
    if abs(imag(z))<1e-4
        ind_del = find(abs(Z-1/z)<1e-4,1);
        Z(ind_del) = 0;
        if sol == 0
            D(1,1) = z;
            D(2,1) = 1/z;
            sol = 2;
            pos = 1;
        else
            D = [D(1:sol,1:n-1);D(1:sol,1:n-1)];
            pos = pos+1;
            D(1:sol,pos) = z;
            D(sol+1:2*sol,pos) = 1/z;
            sol = 2*sol;
        end
        Z = Z(Z~=0);
    else
        ind_del = find(abs(Z-1/z)<1e-4,1);
        Z(ind_del) = 0;
        ind_del = find(abs(Z-1/conj(z))<1e-4,1);
        Z(ind_del) = 0;
        ind_del = find(abs(Z-conj(z))<1e-4,1);
        Z(ind_del) = 0;
        if sol == 0
            D(1,1) = z;
            D(1,2) = conj(z);
            D(2,1) = 1/conj(z);
            D(2,2) = 1/z;
            sol = 2;
            pos = 2;
        else
            D = [D(1:sol,1:n-1);D(1:sol,1:n-1)];
            pos = pos+1;
            D(1:sol,pos) = z;
            D(sol+1:2*sol,pos) = 1/conj(z);
            pos = pos+1;
            D(1:sol,pos) = conj(z);
            D(sol+1:2*sol,pos) = 1/z;
            sol = 2*sol;
        end
        Z = Z(Z~=0);
    end
end

%% Compare the original signal with all possible recovered result

E = [];
for j = 1:size(D,1)
    coeff = poly(D(j,:));
    c = sqrt(r0/sum(abs(coeff).^2,2));
    E = [E;c*coeff];
end

x

E